package task2;

/**
 * A minimal (regular) BST.
 * You can only insert values in this BST.
 * You can ask for the height of this BST or whether it is balanced.
 */
public class BinarySearchTreeSln extends BinarySearchTree {

  @Override
  protected void moodyTraversal(Node node) {
    if (node == null) {
      return;
    }
    boolean visitRootFirst = Coin.flip().equals(Coin.HEAD);
    boolean visitLeftFirst = Coin.flip().equals(Coin.HEAD);
    if (visitRootFirst) {
      System.out.print(node);
    }

    if (visitLeftFirst) {
      moodyTraversal(node.left);
      moodyTraversal(node.right);
    } else {
      moodyTraversal(node.right);
      moodyTraversal(node.left);
    }

    if (!visitRootFirst) {
      System.out.print(node);
    }
  }
}
