package task1;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class BinaryTreeTest {

  @Test
  void example1() {
    /*
     *     2
     *    / \
     *   1   3
     */
    Integer[] input = new Integer[]{2, 1, 3};
    assertTrue(BinaryTree.isValidBst(input));
  }

  @Test
  void example2() {
    /*
     *     5
     *    / \
     *   1   4
     *      / \
     *     3   6
     */
    Integer[] input = new Integer[]{5, 1, 4, null, null, 3, 6};
    assertFalse(BinaryTree.isValidBst(input));
  }

  // TODO add more tests.
}